# ITranslator

The `ITranslator` interface extends [IAsterizmEnv](/infrastructure/asterizm-interfaces/iasterizmenv.md) and provides methods for sending and logging transfer message.

{% @github-files/github-code-block url="<https://github.com/Asterizm-Protocol/asterizm-contracts-evm/blob/master/contracts/interfaces/ITranslator.sol>" %}

### Functions

#### sendMessage

Sends a transfer payload.

**Parameters:** `_dto (`[`TrSendMessageRequestDto`](/infrastructure/asterizm-interfaces/iasterizmenv.md#trsendmessagerequestdto)`)`

#### logExternalMessage

Logs an external transfer payload.

**Parameters:** `_externalRelayAddress (address)`, `_dto (`[`TrSendMessageRequestDto`](/infrastructure/asterizm-interfaces/iasterizmenv.md#trsendmessagerequestdto)`)`

#### resendMessage

Resends a transfer that failed due to insufficient fees.

**Parameters:** `_transferHash (bytes32)`, `_senderAddress (uint)`

#### getLocalChainId

Returns the local chain ID.

**Returns:** `uint64`

#### getChainType

Retrieves the type of chain based on its ID.

**Parameters:** `_chainId (uint64)`

**Returns:** `uint8`

#### getFeeAmountInTokens

Returns the fee amount in tokens for a specified transfer.

**Parameters:** `_dto (`[`TrSendMessageRequestDto`](/infrastructure/asterizm-interfaces/iasterizmenv.md#trsendmessagerequestdto)`)`

**Returns:** `uint`


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.asterizm.io/infrastructure/asterizm-interfaces/itranslator.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
